package nlib.cmm.service.impl;

import java.util.List;
import javax.annotation.Resource;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import nlib.cmm.service.NotificationService;
import nlib.cmm.service.NotificationVO;

/**
 * <pre>
 * @Class Name : NotificationServiceImpl.java
 * 
 * @Description : 알림관련 서비스 구현 클래스  
 * 
 * 
 * @프로젝트명: 지방문화원 통합자료관리시스템 구축사업 (2021)
 *
 * </pre>
 *
 * @ ------------    --------    ---------------------------
 * @ 수정일                     수정자             수정내용
 * @ ------------    --------    ---------------------------
 * @ 2021 09. 06.      KNKIM       최초 생성
 *
 * 
 * @author 이씨플라자 * DIGITALSHIP KNKIM
 * @since 2021 09. 06.
 * @version 1.0
 *
 */
@Service("notificationService")
public class NotificationServiceImpl implements NotificationService
{
	private static final Logger log = LoggerFactory.getLogger(NotificationServiceImpl.class);
	
	@Resource(name="notificationDAO")
	private NotificationDAO notificationDAO;

	/** 
	 * 사용자 알림 목록을 조회한다. 
	 */
	public List<NotificationVO> listNotifications(NotificationVO notificationVO) throws Exception {
		
		return notificationDAO.listNotifications(notificationVO);
	}
	
	/** 
	 * 사용자 알림 목록의 건수를 조회한다.  
	 */
	public int countNotifications(String recvUserId) throws Exception {
		
		return notificationDAO.countNotifications(recvUserId);
	}
	
	/**
	 * 읽지 않은 알림 건수를 조회한다. 
	 * 
	 * @param mbInfoId
	 * @return
	 * @throws Exception
	 */
	public int countUnreadNotification(String recvUserId) throws Exception {
		
		return notificationDAO.countUnreadNotification(recvUserId);
	}

	/**
	 * 알림을 읽음으로 변경한다. 
	 * 만일, 이미 읽음표시된 경우에는 변경 없다. 
	 * 
	 * @param notiVO (notiId, recvUserId 필수)
	 * @return
	 * @throws Exception
	 */
	public int updateRead(NotificationVO notiVO) throws Exception {
		return notificationDAO.updateRead(notiVO);
	}
	
	/**
	 * 알림내용 상세 조회 
	 * 
	 * @param notiVO (notiId, recvUserId 필수)
	 * @return
	 * @throws Exception
	 */
	public NotificationVO selectNotification(NotificationVO notiVO) throws Exception {
		updateRead(notiVO);
		return notificationDAO.selectNotification(notiVO);
	}
	
}